/*
Interactions

`Interactions are managed by our flow designer in UI, what you can control via api is how you start and run interaction flow for contact sending events.  Interaction can start in a multiple ways:  - EntryPont - when contact scans QR code ar opens entry point link  - event as trigger - this way you can start flow for single contact  ## Events Events are a data structure related to some contact action. You can use them whenever you want to start active interaction for contact but also inside interaction flow you can define points wher system should wait for custom event sent from your side.   Depending on your use case our predefined interactions might have defined events and instruction what events should be sent.  Events can be sent directly using our REST Api or triggered automatically by our integration modules.  ## Adding attributes to events Adding attributest to event can personalize communication, select branch flow based on attribute value or use them as perameters in other interaction flow actions. Use `body` property in event structure to add key-value attributes. 

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package interactions

import (
	"encoding/json"
)

// checks if the GetMediaFees200Response type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &GetMediaFees200Response{}

// GetMediaFees200Response struct for GetMediaFees200Response
type GetMediaFees200Response struct {
	Total *int32 `json:"total,omitempty"`
	Results []MediaFee `json:"results,omitempty"`
}

// NewGetMediaFees200Response instantiates a new GetMediaFees200Response object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewGetMediaFees200Response() *GetMediaFees200Response {
	this := GetMediaFees200Response{}
	return &this
}

// NewGetMediaFees200ResponseWithDefaults instantiates a new GetMediaFees200Response object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewGetMediaFees200ResponseWithDefaults() *GetMediaFees200Response {
	this := GetMediaFees200Response{}
	return &this
}

// GetTotal returns the Total field value if set, zero value otherwise.
func (o *GetMediaFees200Response) GetTotal() int32 {
	if o == nil || IsNil(o.Total) {
		var ret int32
		return ret
	}
	return *o.Total
}

// GetTotalOk returns a tuple with the Total field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GetMediaFees200Response) GetTotalOk() (*int32, bool) {
	if o == nil || IsNil(o.Total) {
		return nil, false
	}
	return o.Total, true
}

// HasTotal returns a boolean if a field has been set.
func (o *GetMediaFees200Response) HasTotal() bool {
	if o != nil && !IsNil(o.Total) {
		return true
	}

	return false
}

// SetTotal gets a reference to the given int32 and assigns it to the Total field.
func (o *GetMediaFees200Response) SetTotal(v int32) {
	o.Total = &v
}

// GetResults returns the Results field value if set, zero value otherwise.
func (o *GetMediaFees200Response) GetResults() []MediaFee {
	if o == nil || IsNil(o.Results) {
		var ret []MediaFee
		return ret
	}
	return o.Results
}

// GetResultsOk returns a tuple with the Results field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GetMediaFees200Response) GetResultsOk() ([]MediaFee, bool) {
	if o == nil || IsNil(o.Results) {
		return nil, false
	}
	return o.Results, true
}

// HasResults returns a boolean if a field has been set.
func (o *GetMediaFees200Response) HasResults() bool {
	if o != nil && !IsNil(o.Results) {
		return true
	}

	return false
}

// SetResults gets a reference to the given []MediaFee and assigns it to the Results field.
func (o *GetMediaFees200Response) SetResults(v []MediaFee) {
	o.Results = v
}

func (o GetMediaFees200Response) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o GetMediaFees200Response) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Total) {
		toSerialize["total"] = o.Total
	}
	if !IsNil(o.Results) {
		toSerialize["results"] = o.Results
	}
	return toSerialize, nil
}

type NullableGetMediaFees200Response struct {
	value *GetMediaFees200Response
	isSet bool
}

func (v NullableGetMediaFees200Response) Get() *GetMediaFees200Response {
	return v.value
}

func (v *NullableGetMediaFees200Response) Set(val *GetMediaFees200Response) {
	v.value = val
	v.isSet = true
}

func (v NullableGetMediaFees200Response) IsSet() bool {
	return v.isSet
}

func (v *NullableGetMediaFees200Response) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableGetMediaFees200Response(val *GetMediaFees200Response) *NullableGetMediaFees200Response {
	return &NullableGetMediaFees200Response{value: val, isSet: true}
}

func (v NullableGetMediaFees200Response) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableGetMediaFees200Response) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


